
  -- Color Settings --

  -- Simply change the numbers between 0.0 and 1.0, and voil! --
  -- R = Red, G = Green, B = Blue                              --

  Guild_Roster_Joined_R       = 0.5;
  Guild_Roster_Joined_G       = 1.0;
  Guild_Roster_Joined_B       = 0;

  Guild_Roster_Left_R         = 0.5;
  Guild_Roster_Left_G         = 0.5;
  Guild_Roster_Left_B         = 0.5;

  Guild_Roster_Leveled_R      = 0.4;
  Guild_Roster_Leveled_G      = 0.4;
  Guild_Roster_Leveled_B      = 1.0;

  Guild_Rank_Changed_R        = 1.0;
  Guild_Rank_Changed_G        = 1.0;
  Guild_Rank_Changed_B        = 0.0;

  Guild_Roster_Note_R         = 1.0;
  Guild_Roster_Note_G         = 0.6;
  Guild_Roster_Note_B         = 1.0;

  Guild_Roster_Officer_Note_R = 1.0;
  Guild_Roster_Officer_Note_G = 0.6;
  Guild_Roster_Officer_Note_B = 0.3;

  -- Color Settings --


function Guild_Log_print (message, code)
  -- Get a Frame to write to
  local chatframe = DEFAULT_CHAT_FRAME
  -- touch up message
  message = message or "<nil>"

  if (code == 1) then
    chatframe:AddMessage(message, 1.0, 1.0, 1.0);
  end

  if (code == 2) then
    chatframe:AddMessage(message, 1.0, 1.0, 0);
  end

  if (code == 3) then
    chatframe:AddMessage(message, 0, 0, 1.0);
  end

  if (code == 4) then
    chatframe:AddMessage(message, 0, 1.0, 0);
  end

  if (code == 5) then
    chatframe:AddMessage(message, 1.0, 0, 1.0);
  end

  if (code == 6) then
    chatframe:AddMessage(message, 0, 1.0, 1.0);
  end

  if (code == 0) then
    chatframe:AddMessage(message);
  end

end


function Guild_Log_Add_Log (message, code)

  local dummyLog = {message, code}
  table.insert(Guild_Roster_History_Log, dummyLog);

end


function Guild_Log_Build_History_Array()


  -- Build up the history array. --

  local lastDate = "";
  local i;
  local dummyLog;
  local isDateShownYet = 0;

  dummyLog = {"", -1};
  Guild_Roster_History_Log = {dummyLog};


  for i = table.getn( Guild_Roster_History ), 1 , -1 do

    if (Guild_Roster_History[i][1] ~= "-1") then  -- skip the first entry. --

      if (Guild_Roster_History[i][1] == "1" and Guild_Roster_History_Log_Show_Ranked == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2].." changed rank from "..Guild_Roster_History[i][3].." to "..Guild_Roster_History[i][4], 2 );
      end

      if (Guild_Roster_History[i][1] == "2" and Guild_Roster_History_Log_Show_Leveled == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2] .. " leveled to " .. Guild_Roster_History[i][3], 3 );
      end

      if (Guild_Roster_History[i][1] == "3" and Guild_Roster_History_Log_Show_Joined == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2] .. " joined the guild ( " .. Guild_Roster_History[i][3] .. ", " .. Guild_Roster_History[i][4] .. " )", 4 );
      end

      if (Guild_Roster_History[i][1] == "4" and Guild_Roster_History_Log_Show_Left == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2] .. " left the guild ( " .. Guild_Roster_History[i][3] .. ", " .. Guild_Roster_History[i][4] .. " )", 5 );
      end

      if (Guild_Roster_History[i][1] == "5" and Guild_Roster_History_Log_Show_Note == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2] .. " note changed", 7 );
        Guild_Log_Add_Log ("  From: " .. (Guild_Roster_History[i][3] or ""), 7 );
        Guild_Log_Add_Log ("  To:      " .. (Guild_Roster_History[i][4] or ""), 7 );
      end

      if (Guild_Roster_History[i][1] == "6" and Guild_Roster_History_Log_Show_Officer_Note == 1 ) then
        Guild_Log_Add_Log (Guild_Roster_History[i][5] .. " : " .. Guild_Roster_History[i][2] .. " Officer note changed", 8 );
        Guild_Log_Add_Log ("  From: " .. (Guild_Roster_History[i][3] or ""), 8 );
        Guild_Log_Add_Log ("  To:      " .. (Guild_Roster_History[i][4] or ""), 8 );
      end

    end
  end


end;

function Guild_Log_Convert_History_log()

  local pos, currentDate;

  pos = table.getn(Guild_Roster_History);

  if (pos > 1) then
    if (Guild_Roster_History[1][2] == "data1") then

      local dummyLog = {"-1", "data", "data2", "data3", "date", "" };
      local newLog = { dummyLog };
      local newResult = { dummyLog };

      while pos > 0 do
        if (Guild_Roster_History[pos][1] ~= "-1") then
          if (Guild_Roster_History[pos][1] == "0") then
            currentDate = Guild_Roster_History[pos][2];
          else
            dummyLog = { Guild_Roster_History[pos][1], Guild_Roster_History[pos][2], Guild_Roster_History[pos][3], Guild_Roster_History[pos][4], currentDate, "" };
            table.insert( newLog, dummyLog );
          end;
        end;
        pos = pos - 1;
      end
 
      -- Put the log in the right order. --
      pos = table.getn(newLog);
      while pos > 0 do  -- Do not take the first one. --  
        table.insert( newResult, newLog[pos] );
        pos = pos -1;
      end

      Guild_Roster_History = newResult;  
    
      Guild_Log_print ("GUILD LOG INFO: Your old logs have been converted to the new model, enjoy!!! =)", 6);
      Guild_Roster_Log_Converted = "Y";

    end;
  else
    Guild_Roster_Log_Converted = "Y";
  end;

end;


function Guild_Log_look_Roster( self, showResult )

  -- Convert old History log to new format.  To remove for later versions. --
  if (Guild_Roster_Log_Converted == "N") then
    Guild_Log_Convert_History_log();
  end;

  -- Convert old History log to new format.  To remove for later versions. --


  local dummyChar = {"ZZZZZZZZZZZZZZ", "0", "0", "", "", ""};
  new_GR          = {dummyChar};

  local numGuildMembers = GetNumGuildMembers(true);
  local GuildText       = "";
  local pos             = 0;
  local bad = "N";

  local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(1);
  if ((name or "nil") == "nil") then
    Guild_Log_print ("GetGuildRosterInfo return <nil>, please try reloading your UI", 6);
    bad = "Y";
  end;
  
  -- Create a list of current guild member, ordered by name. --
  if (bad == "N") then
    for i = 1, numGuildMembers, 1 do
      local foundPos = 0;
  
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);

      j = 1;
      while j <= i do
        if (new_GR[j][1] > name) then
          foundPos = j;
          j = i;
        end 
        j = j+1;
      end
      if (foundPos == 0) then
        foundPos = i;
      end

      local newChar = {name, rank, level, note, officernote, class}
      table.insert(new_GR, foundPos, newChar);
      pos = pos + 1;

    end


  -- Check for changes in the guild. --

  local maxNew          = table.getn(new_GR)-1;
  local maxOld          = table.getn(Guild_Roster)-1;
  local LogEntry        = {"0", "", "", "", date("%Y/%m/%d"), "" };
  local lostMember      = {"ZZZZZZZZZZZZZZ", "0", "0", "", "", ""};
  local atLeastOneEntry = "N";
  local nowDate         = date("%Y/%m/%d %H:%M");

  -- Loop on the new members, and update the rank and level. --
  i=1;
  while i <= maxNew do
    j=1;
    while j <= maxOld do
      if (new_GR[i][1] == Guild_Roster[j][1]) then
        -- This guy is still in the guild, woot! --


        -- Rank Changed. --
        if (new_GR[i][2] ~= Guild_Roster[j][2]) then 

          LogEntry = {"1", new_GR[i][1], Guild_Roster[j][2], new_GR[i][2], nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );
          atLeastOneEntry = "Y";
        end

        -- Leveled --
        if (new_GR[i][3] ~= Guild_Roster[j][3]) then 

          LogEntry = { "2", new_GR[i][1], new_GR[i][3], "-", nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );
          atLeastOneEntry = "Y";
          Guild_Log_print (new_GR[i][1] .. " leveled to " .. new_GR[i][3], 6);
        end

        -- Note --
        if (new_GR[i][4] ~= Guild_Roster[j][4]) then 

          LogEntry = { "5", new_GR[i][1], Guild_Roster[j][4], new_GR[i][4], nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );
          atLeastOneEntry = "Y";
          Guild_Log_print (new_GR[i][1] .. "'s public note has changed.", 6);
        end

        -- Officer Note --
        if (new_GR[i][5] ~= Guild_Roster[j][5]) then 

          LogEntry = { "6", new_GR[i][1], Guild_Roster[j][5], new_GR[i][5], nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );
          atLeastOneEntry = "Y";
          Guild_Log_print (new_GR[i][1] .. "'s officer note has changed.", 6);
        end

        j = maxOld + 1;
      else
        if (new_GR[i][1] < Guild_Roster[j][1]) then

          -- Joined the guild. --
          LogEntry = { "3", new_GR[i][1], new_GR[i][2], new_GR[i][3], nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );

          atLeastOneEntry = "Y";

          j = maxOld + 1;
        end
      end
      j = j + 1;
    end
    i = i + 1;
  end

  -- Loop for the left members. --
  i = 1;
  while i <= maxOld do
    j = 1;
    while j <= maxNew do
      if (new_GR[j][1] == Guild_Roster[i][1]) then
        j = maxNew + 1;
      else
        if (Guild_Roster[i][1] < new_GR[j][1]) then
          LogEntry = { "4", Guild_Roster[i][1], Guild_Roster[i][2], Guild_Roster[i][3], nowDate, "" };
          table.insert(Guild_Roster_History, LogEntry );

          lostMember = { Guild_Roster[i][1], Guild_Roster[i][2], Guild_Roster[i][3], Guild_Roster[i][4], Guild_Roster[i][5], date("%Y/%m/%d"), "" };
          table.insert( Guild_Roster_Left_Members, lostMember );

          atLeastOneEntry = "Y";

          j = maxNew + 1;
        end
      end
      j = j + 1;
    end
    i = i + 1;
  end

    Guild_Log_Build_History_Array();

    Guild_Roster     = new_GR;
    Guild_Log_loaded = "Y";
end;

  -- Show the History Panel. --
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);

if (showResult == "Y") then

  Guild_Log_History_Frame:Show();
  Guild_Log_History_ScrollBar:Show();
  Guild_Log_History_Option_Frame:Show();
  
  -- Set the checkboxes default value. --
  if (Guild_Roster_History_Log_Show_Ranked == 2) then
    Guild_Log_History_Option_Frame_Ranked:SetChecked( "nil" );
  end;
  if (Guild_Roster_History_Log_Show_Leveled == 2) then
    Guild_Log_History_Option_Frame_Leveled:SetChecked( "nil" );
  end;

  if (Guild_Roster_History_Log_Show_Joined == 2) then
    Guild_Log_History_Option_Frame_Joined:SetChecked( "nil" );
  end;

  if (Guild_Roster_History_Log_Show_Left == 2 ) then
    Guild_Log_History_Option_Frame_Left:SetChecked( "nil" );
  end;

  if (Guild_Roster_History_Log_Show_Officer_Note == 2 ) then
    Guild_Log_History_Option_Frame_Officer_Note:SetChecked( "nil" );
  end;

  if (Guild_Roster_History_Log_Show_Note == 2 ) then
    Guild_Log_History_Option_Frame_Note:SetChecked( "nil" );
  end;

  if (Guild_Roster_History_Log_Show_On_Load == 1 ) then
    Guild_Log_History_Option_Frame_Show_On_Load:SetChecked( "1" );
  end;

  Guild_Log_History_Option_Frame:Hide();
  Guild_Log_Option_Visible = "N";
end;

end;


function Guild_Log_History_ScrollBar_Update(self)

  local line;           -- 1 through 18 of our window to scroll
  local lineplusoffset; -- an index into our data calculated from the scroll offset
  local chatframe = DEFAULT_CHAT_FRAME


  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);

  for line=1, 18 do

    lineplusoffset = line + FauxScrollFrame_GetOffset( Guild_Log_History_ScrollBar ) + 1;

    if lineplusoffset < (table.getn(Guild_Roster_History_Log)+1) then
      _G["Guild_Log_History_Entry"..line.."_Text"]:SetText( Guild_Roster_History_Log[lineplusoffset][1] );
      

      -- Set the color of the line. --

      if (Guild_Roster_History_Log[lineplusoffset][2] == 1) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( 1.0, 1.0, 1.0 );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 2) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Rank_Changed_R, Guild_Rank_Changed_G, Guild_Rank_Changed_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 3) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Roster_Leveled_R, Guild_Roster_Leveled_G, Guild_Roster_Leveled_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 4) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Roster_Joined_R, Guild_Roster_Joined_G, Guild_Roster_Joined_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 5) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Roster_Left_R, Guild_Roster_Left_G, Guild_Roster_Left_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 7) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Roster_Note_R, Guild_Roster_Note_G, Guild_Roster_Note_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 8) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( Guild_Roster_Officer_Note_R, Guild_Roster_Officer_Note_G, Guild_Roster_Officer_Note_B );
      elseif (Guild_Roster_History_Log[lineplusoffset][2] == 0) then
        _G["Guild_Log_History_Entry"..line.."_Text"]:SetTextColor ( 1.0, 1.0, 1.0 );
      else
        _G["Guild_Log_History_Entry"..line]:Hide();
      end

      _G["Guild_Log_History_Entry"..line]:Show();
    else
     _G["Guild_Log_History_Entry"..line]:Hide();
    end

  end;

end;


function Guild_Log_History_Joined_onClick(self)

  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Joined = 1;
  else
    Guild_Roster_History_Log_Show_Joined = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;

function Guild_Log_History_Left_onClick(self)

  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Left = 1;
  else
    Guild_Roster_History_Log_Show_Left = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end

function Guild_Log_History_Ranked_onClick(self)

  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Ranked = 1;
  else
    Guild_Roster_History_Log_Show_Ranked = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;


function Guild_Log_History_Leveled_onClick(self)

  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Leveled = 1;
  else
    Guild_Roster_History_Log_Show_Leveled = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;

function Guild_Log_History_Show_On_Load_onClick(self)
  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_On_Load = 1;
  else
    Guild_Roster_History_Log_Show_On_Load = 2;
  end;
end;

function Guild_Log_History_Officer_Note_onClick(self)
  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Officer_Note = 1;
  else
    Guild_Roster_History_Log_Show_Officer_Note = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;

function Guild_Log_History_Note_onClick(self)
  if (self:GetChecked() ) then
    Guild_Roster_History_Log_Show_Note = 1;
  else
    Guild_Roster_History_Log_Show_Note = 2;
  end;

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log) -10,5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;

function Guild_Log_Show_Option_onClick(self)
  if (Guild_Log_Option_Visible == "Y" ) then
    Guild_Log_History_Option_Frame:Hide();
    Guild_Log_Option_Visible = "N";
  else
    Guild_Log_History_Option_Frame:Show();
    Guild_Log_Option_Visible = "Y";
  end;
end;


function Guild_Log_History_Clear_Frame_Do_Delete(self)
  
  -- Erase the content of the history log. --

  local dummyLog = {"-1", "data", "data2", "data3", "date" }
  Guild_Roster_History = {dummyLog};

  Guild_Log_History_Clear_Frame:Hide(); 

  Guild_Log_Build_History_Array();
  FauxScrollFrame_Update(Guild_Log_History_ScrollBar, table.getn(Guild_Roster_History_Log),5,16);
  Guild_Log_History_ScrollBar_Update(self);
end;



function Guild_Log_OnLoad(self)

  Guild_Log_loaded = "N";
  Guild_Roster_Log_Converted = "N"; -- only for 1.4. --

  local dummyChar = {"ZZZZZZZZZZZZZZ", "0", "0", "", "", ""};
  Guild_Roster = {dummyChar};
  new_GR       = {dummyChar};

  local dummyLog = {"-1", "data", "data2", "data3", "date", "" }

  Guild_Roster_History = {dummyLog};

  local dummyChar = {"ZZZZZZZZZZZZZZ", "0", "0", "", "", "", "date"};

  Guild_Roster_Left_Members = {dummyChar}

  dummyLog = {"", 0};
  Guild_Roster_History_Log = {dummyLog};

  Guild_Roster_History_Log_Show_Leveled      = 1;
  Guild_Roster_History_Log_Show_Joined       = 1;
  Guild_Roster_History_Log_Show_Left         = 1;
  Guild_Roster_History_Log_Show_Ranked       = 1; 
  Guild_Roster_History_Log_Show_Note         = 1; 
  Guild_Roster_History_Log_Show_Officer_Note = 1; 
  Guild_Roster_History_Log_Show_On_Load      = 2;


  Guild_Log_Option_Visible = "Y";

  Guild_Log_print ("Guild Log v1.5 loaded.", 6);
end

function Guild_Log_History_Frame_onLoad(self)
end

-- ON LOAD MANAGEMENT. --

function Guild_Log_On_Load_OnLoad(self)
  self:RegisterEvent("ADDON_LOADED");
  self.AutoLoginAttempt = 0;
  self.AutoLoginCompleted = 0;
end;

function Guild_Log_On_Load_OnEvent(self, event, ...)
	local arg1 = ...
  if (event == "ADDON_LOADED") then
  	if arg1 == "Guild_Log" then
	    if ( Guild_Roster_History_Log_Show_On_Load == 1 and self.AutoLoginCompleted == 0 ) then
	      self.TimeSinceLastUpdate = 0;
	      self:RegisterEvent("GUILD_ROSTER_UPDATE");
	      self:Show();
	
	      _G["Guild_Log_History_text4"]:SetTextColor ( Guild_Roster_Joined_R, Guild_Roster_Joined_G, Guild_Roster_Joined_B );
	      _G["Guild_Log_History_text3"]:SetTextColor ( Guild_Roster_Left_R, Guild_Roster_Left_G, Guild_Roster_Left_B );
	      _G["Guild_Log_History_text2"]:SetTextColor ( Guild_Rank_Changed_R, Guild_Rank_Changed_G, Guild_Rank_Changed_B );
	      _G["Guild_Log_History_text1"]:SetTextColor ( Guild_Roster_Leveled_R, Guild_Roster_Leveled_G, Guild_Roster_Leveled_B );
	      _G["Guild_Log_History_text0"]:SetTextColor ( Guild_Roster_Note_R, Guild_Roster_Note_G, Guild_Roster_Note_B );
	      _G["Guild_Log_History_text00"]:SetTextColor ( Guild_Roster_Officer_Note_R, Guild_Roster_Officer_Note_G, Guild_Roster_Officer_Note_B );
	
	    end
	  elseif arg1 == "Blizzard_GuildUI" then
	  	if GuildRosterFrame then
	  		Guild_Log_Frame:ClearAllPoints()
	  		Guild_Log_Frame:SetParent(GuildRosterFrame)
	  		Guild_Log_Frame:SetPoint("TOPLEFT",75,-20)
	  		Guild_Log_Frame:Show()
	  	end
    end

  elseif (event == "GUILD_ROSTER_UPDATE") then

    local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(1);
    if name and name ~="" then
      self:UnregisterEvent("GUILD_ROSTER_UPDATE"); -- Stop the calls for Guild Updates. -- 
      self:Hide();                                 -- Stop the OnUpdate calls. --
      self.AutoLoginCompleted = 1;
      Guild_Log_look_Roster(self, "Y");                     -- Do the stuff... --
    else
      self.AutoLoginAttempt = self.AutoLoginAttempt + 1;
    end;
  else
    self.AutoLoginAttempt = self.AutoLoginAttempt + 1;
  end;

  if (self.AutoLoginAttempt == 10) then
    self:UnregisterEvent("GUILD_ROSTER_UPDATE"); -- Stop the calls for Guild Updates. -- 
    self:Hide();                                 -- Stop the OnUpdate calls. --
    Guild_Log_print ("Guild Log Error: failed to start automatically.", 6);
  end;
end

function Guild_Log_On_Load_OnUpdate( self, elapsed )
  if (self.AutoLoginCompleted == 0 ) then
    self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
    if (self.TimeSinceLastUpdate > 3.0) then
      if ( IsInGuild() and self.AutoLoginCompleted == 0 ) then
        GuildRoster();
        self.TimeSinceLastUpdate = 0;
      end;
    end;
  end;
end;


-- Refresh Management. --

function Guild_Log_On_Load_OnLoad2(self)
  self:RegisterEvent("GUILD_ROSTER_UPDATE");
  -- Guild_Log_print ("spam started", 6);
  self.guild_log_refresh_timer = 500.0;
  self.guild_log_roster_called = "N";
end;

function Guild_Log_On_Load_OnEvent2(self, event, ...)

  -- This is meant so that if more than one event happen in a short period of time, it will not blow up. --

  -- if (event == "GUILD_ROSTER_UPDATE" and Guild_Log_loaded == "Y" ) then
  if (event == "GUILD_ROSTER_UPDATE" ) then
    if ( Guild_Log_loaded == "Y" ) then
      -- Guild_Log_print ("Guild Log Event.", 6);
      self.guild_log_refresh_timer = 3.0;
      self:Show();
    end;
  end;
end;

function Guild_Log_On_Load_OnUpdate2( self, elapsed )

  -- An update occured and so we will refresh the data. --

  self.guild_log_refresh_timer = self.guild_log_refresh_timer - elapsed;

  if (self.guild_log_refresh_timer < 3.0 and self.guild_log_roster_called == "N" ) then
    GuildRoster();
    self.guild_log_roster_called = "Y";
  end;

  if (self.guild_log_refresh_timer < 0.0) then
    if (Guild_Log_loaded == "Y") then
      -- Guild_Log_print ("Guild Log Update done.", 6);
      Guild_Log_look_Roster(self, "N");
      -- this:Hide(); -- Stop the OnUpdate calls. --
    else
      Guild_Log_print ("Guild Log not loaded, yet!", 6);  
      -- this:Hide(); -- Stop the OnUpdate calls. --
    end;
    self.guild_log_refresh_timer = 300.0; -- 5 minutes. --
    self.guild_log_roster_called = "N";    
  end;
end;
